// PPgIRC.cpp : implementation file
//

#include "stdafx.h"
#include "emule.h"
#include "PPgIRC.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

// CPPgIRC dialog

IMPLEMENT_DYNAMIC(CPPgIRC, CPropertyPage)
CPPgIRC::CPPgIRC()
	: CPropertyPage(CPPgIRC::IDD)
{
}

CPPgIRC::~CPPgIRC()
{
}

void CPPgIRC::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CPPgIRC, CPropertyPage)
	ON_BN_CLICKED(IDC_IRC_TIMESTAMP, OnBnClickedAddTimeStamp)
	ON_BN_CLICKED(IDC_IRC_USECHANFILTER, OnBnClickedUseFilter)
	ON_BN_CLICKED(IDC_IRC_USEPERFORM, OnBnClickedUsePerform)
	ON_BN_CLICKED(IDC_IRC_ACCEPTLINKS, OnBnClickedAcceptLinks)
	ON_BN_CLICKED(IDC_IRC_INFOMESSAGE, OnBnClickedIgnoreInfoMessages)
	ON_BN_CLICKED(IDC_IRC_EMULEPROTO_INFOMESSAGE, OnBnClickedIgnoreEmuleProtoInfoMessages)
	ON_EN_CHANGE(IDC_IRC_NICK_BOX, OnEnChangeNick)
	ON_EN_CHANGE(IDC_IRC_PERFORM_BOX, OnEnChangePerformString)
	ON_EN_CHANGE(IDC_IRC_SERVER_BOX, OnEnChangeServer)
	ON_EN_CHANGE(IDC_IRC_NAME_BOX, OnEnChangeName)
	ON_EN_CHANGE(IDC_IRC_MINUSER_BOX, OnEnChangeUser)
	ON_BN_CLICKED(IDC_IRC_LISTONCONNECT, OnBnClickedListOnConnect)
END_MESSAGE_MAP()


BOOL CPPgIRC::OnInitDialog()
{
	CPropertyPage::OnInitDialog();
	((CEdit*)GetDlgItem(IDC_IRC_NICK_BOX))->SetLimitText(20);
	((CEdit*)GetDlgItem(IDC_IRC_MINUSER_BOX))->SetLimitText(6);
	((CEdit*)GetDlgItem(IDC_IRC_SERVER_BOX))->SetLimitText(40);
	((CEdit*)GetDlgItem(IDC_IRC_NAME_BOX))->SetLimitText(40);
	((CEdit*)GetDlgItem(IDC_IRC_PERFORM_BOX))->SetLimitText(250);
	LoadSettings();
	Localize();
	m_bnickModified = false;

	return TRUE;  // return TRUE unless you set the focus to a control
	// EXCEPTION: OCX Property Pages should return FALSE
}

void CPPgIRC::LoadSettings(void)
{
	if(app_prefs->GetIRCAddTimestamp())
		CheckDlgButton(IDC_IRC_TIMESTAMP,1);
	else
		CheckDlgButton(IDC_IRC_TIMESTAMP,0);
	if(app_prefs->GetIrcIgnoreInfoMessage())
		CheckDlgButton(IDC_IRC_INFOMESSAGE,1);
	else
		CheckDlgButton(IDC_IRC_INFOMESSAGE,0);
	if(app_prefs->GetIrcIgnoreEmuleProtoInfoMessage())
		CheckDlgButton(IDC_IRC_EMULEPROTO_INFOMESSAGE,1);
	else
		CheckDlgButton(IDC_IRC_EMULEPROTO_INFOMESSAGE,0);
	if(app_prefs->GetIrcAcceptLinks())
		CheckDlgButton(IDC_IRC_ACCEPTLINKS,1);
	else
		CheckDlgButton(IDC_IRC_ACCEPTLINKS,0);
	if(app_prefs->GetIRCUseChanFilter())
		CheckDlgButton(IDC_IRC_USECHANFILTER,1);
	else
		CheckDlgButton(IDC_IRC_USECHANFILTER,0);
	if(app_prefs->GetIrcUsePerform())
		CheckDlgButton(IDC_IRC_USEPERFORM,1);
	else
		CheckDlgButton(IDC_IRC_USEPERFORM,0);
	if(app_prefs->GetIRCListOnConnect())
		CheckDlgButton(IDC_IRC_LISTONCONNECT,1);
	else
		CheckDlgButton(IDC_IRC_LISTONCONNECT,0);
	GetDlgItem(IDC_IRC_SERVER_BOX)->SetWindowText(app_prefs->GetIRCServer());
	GetDlgItem(IDC_IRC_NICK_BOX)->SetWindowText(app_prefs->GetIRCNick());
	GetDlgItem(IDC_IRC_NAME_BOX)->SetWindowText(app_prefs->GetIRCChanNameFilter());
	GetDlgItem(IDC_IRC_PERFORM_BOX)->SetWindowText(app_prefs->GetIrcPerformString());
	CString strBuffer;
	strBuffer.Format("%d", app_prefs->GetIRCChannelUserFilter());
	GetDlgItem(IDC_IRC_MINUSER_BOX)->SetWindowText(strBuffer);

	OnBnClickedUseFilter();
	OnBnClickedUsePerform();	

	SetModified(FALSE);	// FoRcHa
}


BOOL CPPgIRC::OnApply()
{   
//	CSingleLock PrefLock(&(app_prefs->m_Pref_Mutex),TRUE); 

	if(m_bModified)
	{
		if(IsDlgButtonChecked(IDC_IRC_TIMESTAMP))
			app_prefs->SetIRCAddTimestamp(true);
		else
			app_prefs->SetIRCAddTimestamp(false);
		if(IsDlgButtonChecked(IDC_IRC_INFOMESSAGE))
			app_prefs->SetIrcIgnoreInfoMessage(true);
		else
			app_prefs->SetIrcIgnoreInfoMessage(false);
		if(IsDlgButtonChecked(IDC_IRC_EMULEPROTO_INFOMESSAGE))
			app_prefs->SetIrcIgnoreEmuleProtoInfoMessage(true);
		else
			app_prefs->SetIrcIgnoreEmuleProtoInfoMessage(false);
		if(IsDlgButtonChecked(IDC_IRC_ACCEPTLINKS))
			app_prefs->SetIrcAcceptLInks(true);
		else
			app_prefs->SetIrcAcceptLInks(false);
		if(IsDlgButtonChecked(IDC_IRC_LISTONCONNECT))
			app_prefs->SetIRCListonConnect( true);
		else
			app_prefs->SetIRCListonConnect( false);
		if(IsDlgButtonChecked(IDC_IRC_USECHANFILTER))
			app_prefs->SetIRCUseChanFilter(true);
		else
			app_prefs->SetIRCUseChanFilter( false);
		if(IsDlgButtonChecked(IDC_IRC_USEPERFORM))
			app_prefs->SetIrcUsePerform( true);
		else
			app_prefs->SetIrcUsePerform( false);
		char buffer[510];
		if(GetDlgItem(IDC_IRC_NICK_BOX)->GetWindowTextLength())
		{
			GetDlgItem(IDC_IRC_NICK_BOX)->GetWindowText(buffer,20);
			app_prefs->SetIRCNick(buffer);
			//strcpy(app_prefs->prefs->m_sircnick,buffer);
			if( theApp.emuledlg->ircwnd.GetLoggedIn() && m_bnickModified == true){
				m_bnickModified = false;
				theApp.emuledlg->ircwnd.SendString( (CString)"NICK " + (CString)buffer );
			}
		}
	
		if(GetDlgItem(IDC_IRC_SERVER_BOX)->GetWindowTextLength())
		{
			GetDlgItem(IDC_IRC_SERVER_BOX)->GetWindowText(buffer,40);
			app_prefs->SetIRCServer(buffer);
			//strcpy(app_prefs->prefs->m_sircserver,buffer);
		}
	
		if(GetDlgItem(IDC_IRC_NAME_BOX)->GetWindowTextLength())
		{
			GetDlgItem(IDC_IRC_NAME_BOX)->GetWindowText(buffer,40);
			app_prefs->SetIRCChanNameFilter(buffer);
			//strcpy(app_prefs->prefs->m_sircchannamefilter,buffer);
		}
	
		if(GetDlgItem(IDC_IRC_PERFORM_BOX)->GetWindowTextLength())
		{
			GetDlgItem(IDC_IRC_PERFORM_BOX)->GetWindowText(buffer,250);
			app_prefs->SetIRCPerformString(buffer);
			//strcpy(app_prefs->prefs->m_sircperformstring,buffer);
		}
		else
		{
			printf( buffer, " " );
			app_prefs->SetIRCPerformString(buffer);
			//strcpy(app_prefs->prefs->m_sircperformstring,buffer);
		}
	
		if(GetDlgItem(IDC_IRC_MINUSER_BOX)->GetWindowTextLength())
		{
			GetDlgItem(IDC_IRC_MINUSER_BOX)->GetWindowText(buffer,6);
			app_prefs->SetIRCChanUserFilter( atoi(buffer));
		}
		else{
			app_prefs->SetIRCChanUserFilter(0);
		}
	
		SetModified(FALSE);
	}

	return CPropertyPage::OnApply();
}

void CPPgIRC::Localize(void)
{
	if(m_hWnd)
	{
		GetDlgItem(IDC_IRC_SERVER_FRM)->SetWindowText(GetResString(IDS_PW_SERVER));
		GetDlgItem(IDC_IRC_MISC_FRM)->SetWindowText(GetResString(IDS_PW_MISC));
		GetDlgItem(IDC_IRC_TIMESTAMP)->SetWindowText(GetResString(IDS_IRC_ADDTIMESTAMP));
		GetDlgItem(IDC_IRC_NICK_FRM)->SetWindowText(GetResString(IDS_PW_NICK));
		GetDlgItem(IDC_IRC_NAME_TEXT)->SetWindowText(GetResString(IDS_IRC_NAME));
		GetDlgItem(IDC_IRC_MINUSER_TEXT)->SetWindowText(GetResString(IDS_UUSERS));
		GetDlgItem(IDC_IRC_FILTER_FRM)->SetWindowText(GetResString(IDS_IRC_CHANNELLIST));
		GetDlgItem(IDC_IRC_USECHANFILTER)->SetWindowText(GetResString(IDS_IRC_USEFILTER));
		GetDlgItem(IDC_IRC_PERFORM_FRM)->SetWindowText(GetResString(IDS_IRC_PERFORM));
		GetDlgItem(IDC_IRC_USEPERFORM)->SetWindowText(GetResString(IDS_IRC_USEPERFORM));
		GetDlgItem(IDC_IRC_LISTONCONNECT)->SetWindowText(GetResString(IDS_IRC_LOADCHANNELLISTONCON));
		GetDlgItem(IDC_IRC_ACCEPTLINKS)->SetWindowText(GetResString(IDS_IRC_ACCEPTLINKS));
		GetDlgItem(IDC_IRC_INFOMESSAGE)->SetWindowText(GetResString(IDS_IRC_IGNOREINFOMESSAGE));
		GetDlgItem(IDC_IRC_EMULEPROTO_INFOMESSAGE)->SetWindowText(GetResString(IDS_IRC_EMULEPROTO_IGNOREINFOMESSAGE));
	}
}

void CPPgIRC::OnBnClickedUsePerform()
{
	GetDlgItem(IDC_IRC_PERFORM_BOX)->EnableWindow(IsDlgButtonChecked(IDC_IRC_USEPERFORM));	

	SetModified();
}

void CPPgIRC::OnBnClickedUseFilter()
{
	GetDlgItem(IDC_IRC_NAME_BOX)->EnableWindow(IsDlgButtonChecked(IDC_IRC_USECHANFILTER));	
	GetDlgItem(IDC_IRC_MINUSER_BOX)->EnableWindow(IsDlgButtonChecked(IDC_IRC_USECHANFILTER));

	SetModified();
}
