 //this file is part of eMule
//Copyright (C)2002 Merkur ( merkur-@users.sourceforge.net / http://www.emule-project.net )
//
//This program is free software; you can redistribute it and/or
//modify it under the terms of the GNU General Public License
//as published by the Free Software Foundation; either
//version 2 of the License, or (at your option) any later version.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with this program; if not, write to the Free Software
//Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.


#pragma once
#include "serverlistctrl.h"
#include "afxwin.h"
#include "ResizableLib\ResizableDialog.h"
#include "HyperTextCtrl.h"
#include "IconStatic.h"
#include "NewServerDlg.h"
#include "UpdateServerMetDlg.h"
#include "Edit2.h"
#include "XPStyleButtonST.h"
#include "Loggable.h"

// CServerWnd dialog

class CServerWnd : public CResizableDialog, public CLoggable
{
	DECLARE_DYNAMIC(CServerWnd)

	friend class CNewServerDlg;
	friend class CUpdateServerMetDlg;

public:
	CServerWnd(CWnd* pParent = NULL);   // standard constructor
	virtual ~CServerWnd();
	void Localize();
	void ToggleDebugWindow(); //used now!
	void InitFont();		//Cax2
    // Dialog Data
	enum { IDD = IDD_SERVER };
	CServerListCtrl serverlistctrl;
protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	virtual BOOL OnInitDialog();
	virtual void OnCancel();
	DECLARE_MESSAGE_MAP()
public:
	CXPStyleButtonST 	m_ctrlNewServerBtn;
	CXPStyleButtonST 	m_ctrlUpdateServerMetBtn;
	CXPStyleButtonST 	m_ctrlResetLogBtn;
	CHyperTextCtrl 		servermsgbox;
	CEdit2 				logbox;
	CEdit2				debugbox;
	afx_msg void OnBnClickedResetLog();
protected:
	CNewServerDlg 		m_dlgNewServer;
	CUpdateServerMetDlg m_dlgUpdateServerMet;
	bool	debug;
public:
	afx_msg void OnBnClickedUpdateservermet();
	afx_msg void OnBnClickedNewserver();
public:
	void AddServer(CString serveraddr, CString portstr, CString servername);
	void UpdateServerMetFromURL(CString strURL);
	afx_msg void OnStnClickedServinfIco();
	CTabCtrl m_ctrlBoxSwitcher;
	afx_msg void OnTcnSelchangeTab1(NMHDR *pNMHDR, LRESULT *pResult);
//Resources cleanup - [TwoBottle Mod]
	afx_msg void OnDestroy();
private:
	HICON oldServerListIcon;
	CStatic* GetServerLstStatic() const { return (CStatic*)GetDlgItem(IDC_SERVLST_ICO); }
	HICON GetServerLstIcon() const { return (HICON)::LoadImage(AfxGetInstanceHandle(), MAKEINTRESOURCE(IDI_SERVERLIST), IMAGE_ICON, 16, 16, 0); }
};